--- mm-view.el	1999/06/22 23:44:32	1.2
+++ mm-view.el	1999/06/23 00:04:59
@@ -158,13 +158,18 @@
   (goto-char (point-min)))
 
 (defun mm-inline-message (handle)
-  (let ((b (point)))
+  (let ((b (point)) gnus-displaying-mime handles)
     (save-excursion
       (save-restriction
 	(narrow-to-region b b)
 	(mm-insert-part handle)
-	(run-hooks 'gnus-article-decode-hook)
-	(gnus-article-prepare-display)
+	(let (gnus-article-mime-handles)
+	  (run-hooks 'gnus-article-decode-hook)
+	  (gnus-article-prepare-display)
+	  (setq handles gnus-article-mime-handles))
+	(if handles
+	    (setq gnus-article-mime-handles
+		  (append gnus-article-mime-handles handles)))
 	(mm-handle-set-undisplayer
 	 handle
 	 `(lambda ()

--- gnus-art.el	1999/06/22 23:50:50	1.2
+++ gnus-art.el	1999/06/23 00:04:44
@@ -2998,9 +2998,10 @@
 	(when (and (not ihandles)
 		   (not gnus-displaying-mime))
 	  ;; Top-level call; we clean up.
-	  (mm-destroy-parts gnus-article-mime-handles)
-	  (setq gnus-article-mime-handles handles
-		gnus-article-mime-handle-alist nil)
+	  (when gnus-article-mime-handles
+	    (mm-destroy-parts gnus-article-mime-handles)
+	    (setq gnus-article-mime-handle-alist nil)) ;; A trick.
+	  (setq gnus-article-mime-handles handles)
 	  ;; We allow users to glean info from the handles.
 	  (when gnus-article-mime-part-function
 	    (gnus-mime-part-function handles)))
